Cantera 2.6.0

Public Member Functions | Protected Attributes | List of all members
PDSS_Nondimensional Class Reference

Base class for PDSS classes which compute nondimensional properties directly. More...

`#include <PDSS.h>`

Inheritance diagram for PDSS_Nondimensional:
[legend]
Collaboration diagram for PDSS_Nondimensional:
[legend]

## Public Member Functions
virtual doublereal | enthalpy_mole () const
| Return the molar enthalpy in units of J kmol-1. More...
virtual doublereal | entropy_mole () const
| Return the molar entropy in units of J kmol-1 K-1. More...
virtual doublereal | gibbs_mole () const
| Return the molar Gibbs free energy in units of J kmol-1. More...
virtual doublereal | cp_mole () const
| Return the molar const pressure heat capacity in units of J kmol-1 K-1. More...
virtual double | enthalpy_RT_ref () const
| Return the molar enthalpy divided by RT at reference pressure. More...
virtual double | entropy_R_ref () const
| Return the molar entropy divided by R at reference pressure. More...
virtual double | gibbs_RT_ref () const
| Return the molar Gibbs free energy divided by RT at reference pressure. More...
virtual double | cp_R_ref () const
| Return the molar heat capacity divided by R at reference pressure. More...
virtual double | molarVolume_ref () const
| Return the molar volume at reference pressure. More...
virtual double | enthalpy_RT () const
| Return the standard state molar enthalpy divided by RT. More...
virtual double | entropy_R () const
| Return the standard state entropy divided by RT. More...
virtual double | gibbs_RT () const
| Return the molar Gibbs free energy divided by RT. More...
virtual double | cp_R () const
| Return the molar const pressure heat capacity divided by RT. More...
virtual double | molarVolume () const
| Return the molar volume at standard state. More...
virtual double | density () const
| Return the standard state density at standard state. More...
Public Member Functions inherited from PDSS
virtual void | setTemperature (doublereal temp)
| Set the internal temperature. More...
virtual doublereal | temperature () const
| Return the current stored temperature. More...
virtual void | setState_TP (doublereal temp, doublereal pres)
| Set the internal temperature and pressure. More...
virtual void | setState_TR (doublereal temp, doublereal rho)
| Set the internal temperature and density. More...
virtual doublereal | critTemperature () const
| critical temperature More...
virtual doublereal | critPressure () const
| critical pressure More...
virtual doublereal | critDensity () const
| critical density More...
virtual doublereal | satPressure (doublereal T)
| saturation pressure More...
doublereal | molecularWeight () const
| Return the molecular weight of the species in units of kg kmol-1. More...
void | setMolecularWeight (doublereal mw)
| Set the molecular weight of the species. More...
| PDSS ()
| Default Constructor. More...
| PDSS (const PDSS &b)=delete
PDSS & | operator= (const PDSS &b)=delete
virtual | ~PDSS ()
virtual doublereal | intEnergy_mole () const
| Return the molar internal Energy in units of J kmol-1. More...
virtual doublereal | cv_mole () const
| Return the molar const volume heat capacity in units of J kmol-1 K-1. More...
virtual doublereal | enthalpyDelp_mole () const
| Get the difference in the standard state enthalpy between the current pressure and the reference pressure, p0. More...
virtual doublereal | entropyDelp_mole () const
| Get the difference in the standard state entropy between the current pressure and the reference pressure, p0. More...
virtual doublereal | gibbsDelp_mole () const
| Get the difference in the standard state Gibbs free energy between the current pressure and the reference pressure, p0. More...
virtual doublereal | cpDelp_mole () const
| Get the difference in standard state heat capacity between the current pressure and the reference pressure, p0. More...
doublereal | refPressure () const
| Return the reference pressure for this phase. More...
doublereal | minTemp () const
| return the minimum temperature More...
doublereal | maxTemp () const
| return the minimum temperature More...
virtual doublereal | pressure () const
| Returns the pressure (Pa) More...
virtual void | setPressure (doublereal pres)
| Sets the pressure in the object. More...
virtual doublereal | thermalExpansionCoeff () const
| Return the volumetric thermal expansion coefficient. Units: 1/K. More...
void | setReferenceThermo (shared_ptr< SpeciesThermoInterpType > stit)
| Set the SpeciesThermoInterpType object used to calculate reference state properties. More...
virtual void | setParent (VPStandardStateTP *phase, size_t k)
| Set the parent VPStandardStateTP object of this PDSS object. More...
virtual void | initThermo ()
| Initialization routine. More...
void | setParameters (const AnyMap &node)
| Set model parameters from an AnyMap phase description, for example from the `equation-of-state` field of a species definition. More...
virtual void | getParameters (AnyMap &eosNode) const
| Store the parameters needed to reconstruct a copy of this PDSS object. More...
virtual void | setParametersFromXML (const XML_Node &speciesNode)
| Initialization routine for the PDSS object based on the speciesNode. More...
virtual void | reportParams (size_t &kindex, int &type, doublereal *const c, doublereal &minTemp, doublereal &maxTemp, doublereal &refPressure) const
| This utility function reports back the type of parameterization and all of the parameters for the species, index. More...

## Protected Attributes
double | m_h0_RT
| Reference state enthalpy divided by RT. More...
double | m_cp0_R
| Reference state heat capacity divided by R. More...
double | m_s0_R
| Reference state entropy divided by R. More...
double | m_g0_RT
| Reference state Gibbs free energy divided by RT. More...
double | m_V0
| Reference state molar volume (m^3/kmol) More...
double | m_hss_RT
| Standard state enthalpy divided by RT. More...
double | m_cpss_R
| Standard state heat capacity divided by R. More...
double | m_sss_R
| Standard state entropy divided by R. More...
double | m_gss_RT
| Standard state Gibbs free energy divided by RT. More...
double | m_Vss
| Standard State molar volume (m^3/kmol) More...
Protected Attributes inherited from PDSS
doublereal | m_temp
| Current temperature used by the PDSS object. More...
doublereal | m_pres
| State of the system - pressure. More...
doublereal | m_p0
| Reference state pressure of the species. More...
doublereal | m_minTemp
| Minimum temperature. More...
doublereal | m_maxTemp
| Maximum temperature. More...
doublereal | m_mw
| Molecular Weight of the species. More...
AnyMap | m_input
| Input data supplied via setParameters. More...
shared_ptr< SpeciesThermoInterpType > | m_spthermo
| Pointer to the species thermodynamic property manager. More...

## Detailed Description

Base class for PDSS classes which compute nondimensional properties directly.

Definition at line 492 of file PDSS.h.

## Constructor & Destructor Documentation

## ◆ PDSS_Nondimensional()

PDSS_Nondimensional | ( |  | ) |

Definition at line 233 of file PDSS.cpp.

## Member Function Documentation

## ◆ enthalpy_mole()

doublereal enthalpy_mole | ( |  | ) | const
| virtual

Return the molar enthalpy in units of J kmol-1.

Returns
  the species standard state enthalpy in J kmol-1 at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 247 of file PDSS.cpp.

References PDSS_Nondimensional::enthalpy_RT(), Cantera::GasConstant, and PDSS::temperature().

## ◆ entropy_mole()

doublereal entropy_mole | ( |  | ) | const
| virtual

Return the molar entropy in units of J kmol-1 K-1.

Returns
  The species standard state entropy in J kmol-1 K-1 at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 252 of file PDSS.cpp.

References PDSS_Nondimensional::entropy_R(), and Cantera::GasConstant.

## ◆ gibbs_mole()

doublereal gibbs_mole | ( |  | ) | const
| virtual

Return the molar Gibbs free energy in units of J kmol-1.

Returns
  The species standard state Gibbs free energy in J kmol-1 at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 257 of file PDSS.cpp.

References Cantera::GasConstant, PDSS_Nondimensional::gibbs_RT(), and PDSS::temperature().

## ◆ cp_mole()

doublereal cp_mole | ( |  | ) | const
| virtual

Return the molar const pressure heat capacity in units of J kmol-1 K-1.

Returns
  The species standard state Cp in J kmol-1 K-1 at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 262 of file PDSS.cpp.

References PDSS_Nondimensional::cp_R(), and Cantera::GasConstant.

Referenced by PDSS_ConstVol::cv_mole(), PDSS_IdealGas::cv_mole(), and PDSS_SSVol::cv_mole().

## ◆ enthalpy_RT_ref()

double enthalpy_RT_ref | ( |  | ) | const
| virtual

Return the molar enthalpy divided by RT at reference pressure.

Returns
  The species reference state enthalpy at the current temperature, divided by RT.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 272 of file PDSS.cpp.

References PDSS_Nondimensional::m_h0_RT.

## ◆ entropy_R_ref()

double entropy_R_ref | ( |  | ) | const
| virtual

Return the molar entropy divided by R at reference pressure.

Returns
  The species reference state entropy at the current temperature, divided by R.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 277 of file PDSS.cpp.

References PDSS_Nondimensional::m_s0_R.

## ◆ gibbs_RT_ref()

double gibbs_RT_ref | ( |  | ) | const
| virtual

Return the molar Gibbs free energy divided by RT at reference pressure.

Returns
  The reference state Gibbs free energy at the current temperature, divided by RT.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 267 of file PDSS.cpp.

References PDSS_Nondimensional::m_g0_RT.

## ◆ cp_R_ref()

double cp_R_ref | ( |  | ) | const
| virtual

Return the molar heat capacity divided by R at reference pressure.

Returns
  The species reference state heat capacity divided by R at the current temperature.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 282 of file PDSS.cpp.

References PDSS_Nondimensional::m_cp0_R.

## ◆ molarVolume_ref()

double molarVolume_ref | ( |  | ) | const
| virtual

Return the molar volume at reference pressure.

Returns
  The reference state molar volume. units are m**3 kmol-1.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 287 of file PDSS.cpp.

References PDSS_Nondimensional::m_V0.

## ◆ enthalpy_RT()

double enthalpy_RT | ( |  | ) | const
| virtual

Return the standard state molar enthalpy divided by RT.

Returns
  The dimensionless species standard state enthalpy divided at the current temperature and pressure.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 292 of file PDSS.cpp.

References PDSS_Nondimensional::m_hss_RT.

Referenced by PDSS_Nondimensional::enthalpy_mole().

## ◆ entropy_R()

double entropy_R | ( |  | ) | const
| virtual

Return the standard state entropy divided by RT.

Returns
  The species standard state entropy divided by RT at the current temperature and pressure.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 297 of file PDSS.cpp.

References PDSS_Nondimensional::m_sss_R.

Referenced by PDSS_Nondimensional::entropy_mole().

## ◆ gibbs_RT()

double gibbs_RT | ( |  | ) | const
| virtual

Return the molar Gibbs free energy divided by RT.

Returns
  The species standard state Gibbs free energy divided by RT at the current temperature and pressure.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 302 of file PDSS.cpp.

References PDSS_Nondimensional::m_gss_RT.

Referenced by PDSS_Nondimensional::gibbs_mole().

## ◆ cp_R()

double cp_R | ( |  | ) | const
| virtual

Return the molar const pressure heat capacity divided by RT.

Returns
  The species standard state Cp divided by RT at the current temperature and pressure.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 307 of file PDSS.cpp.

References PDSS_Nondimensional::m_cpss_R.

Referenced by PDSS_Nondimensional::cp_mole().

## ◆ molarVolume()

double molarVolume | ( |  | ) | const
| virtual

Return the molar volume at standard state.

Returns
  The standard state molar volume at the current temperature and pressure. Units are m**3 kmol-1.

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 312 of file PDSS.cpp.

References PDSS_Nondimensional::m_Vss.

## ◆ density()

double density | ( |  | ) | const
| virtual

Return the standard state density at standard state.

Returns
  The standard state density at the current temperature and pressure. units are kg m-3

Reimplemented from PDSS.

Reimplemented in PDSS_IonsFromNeutral.

Definition at line 317 of file PDSS.cpp.

References PDSS::m_mw, and PDSS_Nondimensional::m_Vss.

## Member Data Documentation

## ◆ m_h0_RT

double m_h0_RT
| protected

Reference state enthalpy divided by RT.

Definition at line 515 of file PDSS.h.

Referenced by PDSS_Nondimensional::enthalpy_RT_ref(), PDSS_ConstVol::intEnergy_mole(), PDSS_IdealGas::intEnergy_mole(), PDSS_IonsFromNeutral::intEnergy_mole(), PDSS_SSVol::intEnergy_mole(), PDSS_ConstVol::setPressure(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_cp0_R

double m_cp0_R
| protected

Reference state heat capacity divided by R.

Definition at line 516 of file PDSS.h.

Referenced by PDSS_Nondimensional::cp_R_ref(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_s0_R

double m_s0_R
| protected

Reference state entropy divided by R.

Definition at line 517 of file PDSS.h.

Referenced by PDSS_Nondimensional::entropy_R_ref(), PDSS_IdealGas::setPressure(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_g0_RT

double m_g0_RT
| protected

Reference state Gibbs free energy divided by RT.

Definition at line 518 of file PDSS.h.

Referenced by PDSS_Nondimensional::gibbs_RT_ref(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_V0

double m_V0
| protected

Reference state molar volume (m^3/kmol)

Definition at line 519 of file PDSS.h.

Referenced by PDSS_SSVol::calcMolarVolume(), PDSS_ConstVol::cv_mole(), PDSS_SSVol::cv_mole(), PDSS_ConstVol::initThermo(), PDSS_Nondimensional::molarVolume_ref(), and PDSS_IdealGas::setTemperature().

## ◆ m_hss_RT

double m_hss_RT
| protected

Standard state enthalpy divided by RT.

Definition at line 520 of file PDSS.h.

Referenced by PDSS_Nondimensional::enthalpy_RT(), PDSS_ConstVol::setPressure(), PDSS_IdealGas::setPressure(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_cpss_R

double m_cpss_R
| protected

Standard state heat capacity divided by R.

Definition at line 521 of file PDSS.h.

Referenced by PDSS_Nondimensional::cp_R(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_sss_R

double m_sss_R
| protected

Standard state entropy divided by R.

Definition at line 522 of file PDSS.h.

Referenced by PDSS_Nondimensional::entropy_R(), PDSS_ConstVol::setPressure(), PDSS_IdealGas::setPressure(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_gss_RT

double m_gss_RT
| protected

Standard state Gibbs free energy divided by RT.

Definition at line 523 of file PDSS.h.

Referenced by PDSS_Nondimensional::gibbs_RT(), PDSS_ConstVol::setPressure(), PDSS_IdealGas::setPressure(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

## ◆ m_Vss

double m_Vss
| protected

Standard State molar volume (m^3/kmol)

Definition at line 524 of file PDSS.h.

Referenced by PDSS_SSVol::calcMolarVolume(), PDSS_Nondimensional::density(), PDSS_ConstVol::initThermo(), PDSS_ConstVol::intEnergy_mole(), PDSS_SSVol::intEnergy_mole(), PDSS_Nondimensional::molarVolume(), PDSS_ConstVol::setPressure(), PDSS_IdealGas::setPressure(), PDSS_SSVol::setPressure(), PDSS_ConstVol::setTemperature(), PDSS_IdealGas::setTemperature(), and PDSS_SSVol::setTemperature().

The documentation for this class was generated from the following files:

- PDSS.h
- PDSS.cpp